/* fou.c*/
double 	TWOPI, PI;
float  	scalef;
int 	scale;
long int lenin;

float   *sbuf1;
float   *tbuf1;
float   *filt1;
float   *sbuf2;
float   *tbuf2;
float   *filt2;
float   *dbuf1;
float   *dbuf2;
float	*delarray1,*delarray2;

#include "convolve.h"
#include "longfft.c"
#include "filefunc.c"
#include "convfunc.c"
/*#################################################################*/
/*#########################################################################
###########################---MAIN---######################################
###########################################################################*/
int main(int argv,char *argc[])
{
PI	=4.*atan(1.);
TWOPI	=2*PI;
HEADER 	hedh;
FOU    	fou;
char  	magic[5]= "FOUR";
float  	*cha1;
float  	*cha2;
FILE 	*in, *impulse;
int     nargs=3;/*exe, infile,outfile*/
long int N=0,N2=0,n=0,length=0;
long int NCMAX=1048576/*2^20*/;
float 	duracion=0.;
/*#####################################*/
fprintf(stderr,"\n FOU \n by Pablo Di Liscia");
fprintf(stderr,"\n Last Linux version 2/20/99");

if(argv<nargs)
	{fprintf(stderr,"FOU.EXE: \n"\
	"NOT ENOUGH ARGUMENTS (%d)\n"
	"\n usage: fou, (infile(.wav),(outfile(*.fou))"
	,argv-1);exit(-1);}
scale	=(int)pow(2.,15.);
scalef=1./scale;
fprintf(stderr,"\n\n INFILE =");
if((in=openwav(&hedh,&duracion,LEER,STEREO,argc[1]))==NULL)
	{exit(-1);}
fprintf(stderr," \n OUTFILE = %s", argc[2]);
/*###############################*/
	length=(long int)(hedh.datl/hedh.ba);

	for(N2=2;N2<NCMAX; N2*=2){
		if(N2>=length) break;
		}
	N=2*N2;
	fprintf(stderr,"\n FFT SIZE=  %ld points\n",N);
	fprintf(stderr," RAM USED=  %ld K\n",(N2*20)/1024);
/*###############################*/
fou.ncha=(short)hedh.cha;		
fou.SR  =(unsigned int)hedh.SR;	
fou.flen=(int)((N*fou.ncha*4)+24);   
fou.wlen=(int)hedh.datl;   	
fou.dlen=(int)N;           		

for(n=0;n<4;++n){
	fou.four[n]=magic[n];
	}
if((impulse=openfou(argc[2],&fou,ESCR))==NULL)
	{fclose(in);exit(-1);}
/*###############################*/
  if((cha1=(float *)aloca((N+2)*sizeof(float)))==NULL){
		fclose(in);fclose(impulse);
		exit(-1);}
  if(fou.ncha==2){
		if((cha2=(float *)aloca((N+2)*sizeof(float)))==NULL){
		fclose(in);fclose(impulse);
		exit(-1);}
		}

/*##############################*/
 readfile(length,in,cha1,cha2,hedh.cha);
 for(n=length;n<N+2;n++){
		cha1[n]=0.;
		if(fou.ncha==2)
			{cha2[n]=0.;}
		}
/*##############################*/
	fprintf(stderr," PERFORMING AND WRITTING FFT...");
	cfast(cha1,N);
	if(fou.ncha==2){
	cfast(cha2,N);
	}
	
  writefou (N,impulse,cha1,cha2,fou.ncha);
  fprintf(stderr,"O.K. ");
/*##############################*/

fprintf(stderr,"( %d floats written )",fou.dlen*(int)fou.ncha);
fclose(in);fclose(impulse);
free(cha1);
if(fou.ncha==2){free(cha2);}
fprintf(stderr,"\n DONE...!!!\n\n");
return 0;
}

/*#####################################################*/

