/* convfunc.c */
/*#####################################*/
void    *aloca	    	(size_t size);
void     readfile   	(long int size,FILE *fpti,float *array1,float *array2,int cha );
void 	 writefloat 	(FILE *fpto, float flotsam,long int *nwri,float *maxgain,long int *clip);
int	 	 readfloat  	(FILE *fpti,float *array,long int point,long int *count);
void 	 closefile  	(FILE *in,FILE *out,FILE *impulse);
void 	 cmult		(float  *fl,float  *sbu,long int n);
void 	 cdiv		(float  *fl,float  *sbu,long int n);
void  	 label		();
int      normalizar     (float *filt,float gain,long int N,long int N2,long int mod);
void  	 what_is	(FILE *fpt,int *eswav,int *esfou);
FILE	 *openfou	(char *name,FOU *fu,int kind);
int      readfou 	(long int size,FILE *fpti,float *cha1,float *cha2,int cha);
float    fdelay		(float sample,float *array, int *delpo, int delay);
int      writefou   (long int size,FILE *fpti,float *cha1,float *cha2,int cha);
void     dealoc     (int stereo);

/*#####################################################*/
void     dealoc         (int stereo)
{
   if(sbuf1)
    free(sbuf1);
   if(tbuf1)
    free(tbuf1);
    if(filt1)
    free(filt1);
     if(dbuf1)
    free(dbuf1);
     if(delarray1)
    free(delarray1);
 
 if(stereo){
    if(sbuf2)
    free(sbuf2);
   if(tbuf2)
    free(tbuf2);
    if(filt2)
    free(filt2);
     if(dbuf2)
    free(dbuf2);
     if(delarray2)
    free(delarray2);
  }
return; 
}
/*#####################################################*/
int  writefou (long int size,FILE *fpti,float *cha1,float *cha2,int cha)
{
float flotsam;
long int i;

	 for(i=0;i<size;++i){
		flotsam=cha1[i];
		if((fwrite(&flotsam,sizeof(float),1,fpti))==0)
			{fprintf(stderr,"\n ERROR WRITING OUTFILE...");
			 return(0);}
	 
	 }

if(cha==2){
    for(i=0;i<size;++i){
		flotsam=cha2[i];
		if((fwrite(&flotsam,sizeof(float),1,fpti))==0)
			{fprintf(stderr,"\n ERROR WRITING OUTFILE...");
			 return(0);}
	 }
  }

return(1);
}
/*#########################################################*/
float fdelay(float sample,float *array, int *delpo, int delay)
{
float out;
 	
	if(delay==0)		{return(sample);}
	out=array[*delpo];
	array[*delpo]=sample;
	if(++*delpo>delay)	{*delpo=0;}
		
return(out);
}
/*#########################################################*/
void writefloat(FILE *fpto, float flotsam,long int *nwri, float *maxgain,long int *clip)
 {
 short sample;

	if(fabs((double)flotsam)>*maxgain)
		{*maxgain=(float)fabs((double)flotsam);}
	if(*maxgain>1.)
		{++*clip;}
	sample=(short)(flotsam*scale);
	if(fwrite(&sample,sizeof(short),1,fpto)==0)
	{printf("\nERROR WRITING OUTFILE");
	 printf("\n%ld SAMPLES WRITTEN \n",*nwri);return;
	 }

	++*nwri;

 return;
 }
/*#######################################################################*/
int	 readfloat 	(FILE *fpti, float *array,long int point,long int *count)

{
short sample;
			if(*count<lenin){
			fread(&sample,sizeof(short),1,fpti);
			array[point]=(float)(sample*scalef);
			++*count;
			}
			else{
			return(0);
			}
return(1);
}
 /*###########################################################################*/
void readfile (long int size,FILE *fpti,float *array1,float *array2,int cha )
 {
 short sample;
 long int i;
	fprintf(stderr,"\n ALOCATING IMPULSE RESPONSE FILE ON RAM...");

	for(i=0;i<size;++i){
		fread(&sample,sizeof(short),1,fpti);
		array1[i]=(float)(sample*scalef);
		if(cha==2)
			{fread(&sample,sizeof(short),1,fpti);
			array2[i]=(float)(sample*scalef);}
	}

 fprintf(stderr,"O.K.\n");
 return;
 }
 /*#####################################################*/
 void *aloca(size_t size)
 {

 void *pointer;	
 		pointer=(void *)malloc(size);
		if(pointer==NULL)	
			{
			fprintf(stderr,"\n UUUPS...not enough RAM memory, chau! \n\n");
			return(NULL);
			}
 
 
 
 return(pointer);
 }
 
 /*#####################################################*/
 void closefile       (FILE *in,FILE *out,FILE *impulse)
 {
 fclose(in);fclose(out);fclose(impulse);
 }
 /*#####################################################*/
 void label()
{
printf("WCONVOLVE\n");
printf("by Oscar Pablo Di Liscia\n");
printf("LAST WINDOWS VERSION: 25/7/99\n");
 }
/*###############################################################*/
int  normalizar(float  *filt,float gain,long int N,long int N2,long int mod)
{
float a=0.,b=0.,temp=0., max=0.;
long int i=0;

	for(i=0;i<=N2;i++){
		a 	  = filt[2*i];
		b 	  = filt[2*i + 1];
		temp 	  = a*a + b*b;
		if (temp > max)
		   max = temp;
		}
	if (max !=0.)
		max = gain / (sqrt(max));
	else {return(0);}

	if (mod==1)
	max=1./max;

	for(i=0;i<N+2;i++){
		filt[i]*=max;
		}
return(1);
}
/*######################COMPLEX MULTIPLICATION#########################################*/
void cmult	(float *fl,float *sbu,long int n)
{
 long int i,ip=0,ip1=0;
 float a=0,b=0;
			for(i=0;i<=n;i++){
				ip	=2*i;
				ip1	=ip+1;
				a	=sbu[ip] * fl[ip]  - sbu[ip1] * fl[ip1];
				b	=sbu[ip] * fl[ip1] + sbu[ip1] * fl[ip];
				sbu[ip] = a;
				sbu[ip1]= b;
			}
return;
}
/*#####################COMPLEX DIVISION##########################################*/
void cdiv	(float *fl,float *sbu,long int n)
{
long int i,ip=0,ip1=0;
float a=0.,b=0.,cd=0.;
			for(i=0;i<=n;i++){
				ip	=2*i;
				ip1 =ip+1;
				cd	= (fl[ip]*fl[ip])+(fl[ip1]*fl[ip1]);
				a	=sbu[ip] * fl[ip]  + sbu[ip1] * fl[ip1];
				b	=sbu[ip1] * fl[ip] - sbu[ip] * fl[ip1];

				if(cd!=0.){
				sbu[ip]  = a/cd;
				sbu[ip1] = b/cd;
				}
				else  /*we don't want to divide by zero...*/
				{sbu[ip] =a;
				 sbu[ip1]=b;}
				}
return;
}
/*#####################################################*/
void  	 what_is	(FILE *fpt,int *eswav,int *esfou)
{
 char rif[5]="RIFF";
 char fou[5]="FOUR";
 short i;
 char  aux;	
 	for(i=0;i<4;++i)
 	{
 		fread(&aux,sizeof(char),1,fpt); 	 
 		if(aux==rif[i]) {++*eswav;}
 		if(aux==fou[i]) {++*esfou;}
 	}	
	
	if(*eswav==4){*esfou=0;*eswav=1;return;}
	if(*esfou==4){*esfou=1;*eswav=0;return;}
return;
}
/*#####################################################*/
 FILE	*openfou(char *name,FOU *fu,int kind)
 {
 FILE *fpt;
 int largo=0,larch=0;
 FOU pu;
 	
	if(kind==2){ /*OUTPUT FILE(used by Fou)*/
		if((fpt=fopen(name,"wb"))==NULL)
		{printf("\n CAN'T OPEN %s\n", name);
		 return(0);}
	pu=*fu;	 
	if(fwrite(&pu,sizeof(FOU),1,fpt)==0)
		{fprintf(stderr,"\n ERROR WRITTING OUTFILE(fou)...\n\n");
		return(0);}
	
	return(fpt);}


	if(kind==1)  /*INPUT FILE(used by Convolve)*/
		if((fpt=fopen(name,"rb"))==NULL)
		{printf("\n CAN'T OPEN %s\n", name);
		 return(0);}
		
		if(fread(&pu,sizeof(FOU),1,fpt)==0) {fprintf(stderr,"\n ERROR READING %s \n",name);return(0);}
		fprintf(stderr,"\n'%s'= ",name);
		if(pu.ncha==1)
				{fprintf(stderr,"MONO,");}
		else
				{fprintf(stderr,"STEREO,");}
		{fprintf(stderr," %d Hz,", pu.SR);}
		{fprintf(stderr,"\n %d bytes,", pu.flen);}
		{fprintf(stderr," %6.3f segs \n", (float)(pu.wlen/pu.SR/2.));}
		/*the better I can do is to check length of file to see if matches with length written on header*/
		larch=filelength(fpt);
		largo=pu.flen;	     
		if (larch!=largo)
		{printf("\n%s C'EST PAS UN FICHIER *.fou...ADIEU \n\n",name);
		return(0);}
		*fu=pu;/* it does...!!!*/		

 return(fpt);
 }
 /*#####################################################*/
int     readfou (long int size,FILE *fpti,float *cha1,float *cha2,int cha)
{
float flotsam;
long int i;

	 for(i=0;i<size;++i){
		if((fread(&flotsam,sizeof(float),1,fpti))==0)
			{printf("\n ERROR READING INFILE(fou)...\n\n");
			 return(0);}
	 cha1[i]=flotsam;
	 }


if(cha==2){
	 for(i=0;i<size;++i){
		if((fread(&flotsam,sizeof(float),1,fpti))==0)
			{printf("\n ERROR READING INFILE(fou)...\n\n");
			 return(0);}
	 cha2[i]=flotsam;
	 }
  }
return(1);
}
 /*#####################################################*/
