/*convolve.h*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*#include <values.h>*/

#define LEER 1
#define ESCR 2
#define MONO 1
#define STEREO 2

typedef struct {           		/*STRUCT FOR RIFF WAVE HEADERS*/
	char rif[4];      			/*RIFF*/
	unsigned  int length; 		/*length of file (bytes)*/
	char wa[4];      			/*WAVE */
	char fm[4];      			/*fmt */
	unsigned int ldat;   		/*length of data block (usualy 16 bytes)*/
	unsigned short int tag;  	/*format tag (01)=pcm*/
	unsigned short int cha;   	/*channels 1=mono, 2=stereo*/
	unsigned  int SR;     		/*SAMPLING RATE*/
	unsigned  int ASS;    		/*average bytes per sec.*/
	unsigned short int ba;    	/*block alignment */
	unsigned short int res;   	/*bits per sample*/
	char dat[4];     			/*data*/
	unsigned int datl;   		/*length of audio data (bytes)*/
	}HEADER;

	
typedef struct{                 /*STRUCT FOR FFT FILES (it will be written by 'fou', and 'read' by convolve*/
	char			four[4]; 	/*FOUR*/
	short      		ncha;    	/*channels*/
    unsigned int 	SR; 		/*SR*/
    int 			flen;   	/*length of this file (bytes)*/
	int 			wlen;    	/*lenght of the wave file from which this was made (samples)*/
	int 			dlen;    	/*FFT length (power of two)*/
	}FOU;

