/*filefunc.c*/
FILE  *openwav		(HEADER *phe,float *dura,short flag,short cha,char *filename);
int   checkhead		(HEADER he,  FILE *fpti);
float printhead	        (HEADER he,  FILE *fpti);
int   filelength        (FILE   *fpt);
/*#################################################################*/
int filelength(FILE *fpt)
{
int size=0;
int actual=ftell(fpt);
	
	fseek(fpt,0,SEEK_END);
	size=ftell(fpt);
	fseek(fpt,actual,SEEK_SET);

return(size);
}
/*#################################################################*/
int checkhead(HEADER he,FILE *fpti)/*check file header for errors*/
{
char RIFF[5]="RIFF",WAVE[5]="WAVE",FM[5]="fmt ",DATA[5]="data";
short i;
	for(i=0;i<4;++i){
		if(RIFF[i]!=he.rif[i] || WAVE[i]!=he.wa[i] || FM[i]!=he.fm[i] || DATA[i]!=he.dat[i])
		{printf("\n WARNING!: ALIEN STRING ON HEADER\n");break;}
	}
	if (filelength(fpti)==0 || filelength(fpti)!=(int)(he.length+8))
		{printf("\n(length)= %9d real= %d",he.length,filelength(fpti));goto archerr;}
	if (he.tag !=1)
		{printf("\n(tag)= %9u",he.tag);goto archerr;}
	if (he.cha==0 || he.cha>2)
		{printf("\n(cha)= %9u ",he.cha);goto archerr;}
	if (he.SR==0 || he.SR>44100)
		{printf("\n(SR )= %9d ",he.SR);goto archerr;}
	if (he.ASS==0 || he.ASS !=(he.SR*he.cha*(he.res/8)))
		{printf("\n(ASS)= %9d",he.ASS);goto archerr;}
	
	if (he.ba !=he.cha*(he.res/8))
		{printf("\n(BA )= %9u ",he.ba);goto archerr;}
return(0);
archerr:return(-1);
}
/*###########################################################################*/
float printhead(HEADER he,FILE *fpti)/*prints header and get duration of soundfile*/
{
float duracion;

	  if(he.cha==1){printf("MONO, ");}
	  else{printf("STEREO, ");}

					printf("%d Hz, %u bits\n",he.SR,he.res);
					printf(" %d samples, ",he.datl/2);
					duracion=(float)he.datl/he.ASS;
					printf("%.3f segs., ",duracion);
					printf("%d bytes\n",filelength(fpti));
return(duracion);
}
/*###########################################################################*/
/*open the file for input or output*/
FILE *openwav(HEADER *phe,float *dura,short flag,short cha,char *filename)
{

HEADER he;
FILE *fpt;

if(flag==2){ /*it is an output file*/
	if((fpt=fopen(filename,"wb"))==0)
	{printf("ERROR-CAN'T OPEN %s ...\n",filename);
	 return(0);
	 }
	 
	he=*phe;
	fwrite(&he,sizeof(HEADER),1,fpt);
	return(fpt);}

if(flag==1)  /*it is an input file*/
	printf("\n'%s'= ",filename);

	if ((fpt=fopen(filename, "rb"))==0)
	{printf("ERROR-CAN'T OPEN %s ...\n",filename);
	return(0);}
			fread(&he,sizeof(HEADER),1,fpt);
			if (checkhead(he,fpt)==-1)
			{printf("\n%s IS NOT A VALID WAV FILE...\n",filename);return(0);}

         if (he.res !=16)
			{printf("SORRY, ONLY 16 BITS LINEAR ALLOWED...\n");
			fclose(fpt);return(0);}
			if (cha==1 && he.cha==2)
			{printf("SORRY, I DO NOT WORK WITH STEREO FILES...\n");
			fclose(fpt);return(0);}
*dura=(printhead(he,fpt));
*phe=he;
return(fpt);
            

 }
